 %dcl #_wtypes_h__ char ext;
 %if #_wtypes_h__ = '' %then %do;
 %#_wtypes_h__ = 'Y';

 /* verify that the <rpcndr.cpy> version is high enough */
 /* to compile this file                                */
 %dcl #_RPCNDR_H_VERSION__ fixed ext;
 %if #_RPCNDR_H_VERSION__ = 0 %then %do;
   %#_RPCNDR_H_VERSION__ = 475;
 %end; /* __RPCNDR_H_VERSION__ */

 %dcl #_RPC_H__ char ext;
 %if #_RPC_H__ = '' %then %do;
 %include rpc;
 %end;
 %dcl #_RPCNDR_H__ char ext;
 %if #_RPCNDR_H__ = '' %then %do;
 %include rpcndr;
 %end;

 %dcl #_RPCNDR_H_VERSION__ fixed ext;
 %if #_RPCNDR_H_VERSION__ = 0 %then %do;
   %note('This stub requires an updated version of <rpcndr.cpy>', 8);
 %end; /* __RPCNDR_H_VERSION__ */


 /* header files for imported files */
 /* %include basetsd - already included by rpcndr.cpy */
 %dcl #GUIDDEF_H_ char ext;
 %if #GUIDDEF_H_ = '' %then %do;
 %include guiddef;
 %end;

 /* MIDL_user_allocate and MIDL_user_free declared in rpcndr.cpy */


 /* interface __MIDL_itf_wtypes_0000 */
 /* [local] */

 /* +---------------------------------------------------------------- */
 /*                                                                   */
 /* Microsoft Windows                                                 */
 /* Copyright (C) Microsoft Corporation, 1992-1999.                   */
 /*                                                                   */
 /* ----------------------------------------------------------------- */


 dcl __MIDL_itf_wtypes_0000_v0_0_c_ifspec type RPC_IF_HANDLE ext static;
 dcl __MIDL_itf_wtypes_0000_v0_0_s_ifspec type RPC_IF_HANDLE ext static;

 %dcl #_IWinTypes_INTERFACE_DEFINED__ char ext;
 %if #_IWinTypes_INTERFACE_DEFINED__ = '' %then %do;
 %#_IWinTypes_INTERFACE_DEFINED__ = 'Y';

 /* interface IWinTypes */
 /* [auto_handle][unique][version][uuid] */

 define structure
   1 RemHGLOBAL,
     2 fNullHGlobal fixed bin(31),
     2 cbData       unsigned fixed bin(32),
     2 data (1)     type byte; /* [size_is] */

 define structure
   1 RemHMETAFILEPICT,
     2 mm       fixed bin(31),
     2 xExt     fixed bin(31),
     2 yExt     fixed bin(31),
     2 cbData   unsigned fixed bin(32),
     2 data (1) type byte; /* [size_is] */

 define structure
   1 RemHENHMETAFILE,
     2 cbData   unsigned fixed bin(32),
     2 data (1) type byte; /* [size_is] */

 define structure
   1 RemHBITMAP,
     2 cbData   unsigned fixed bin(32),
     2 data (1) type byte; /* [size_is] */

 define structure
   1 RemHPALETTE,
     2 cbData   unsigned fixed bin(32),
     2 data (1) type byte; /* [size_is] */

 define structure
   1 RemBRUSH,
     2 cbData   unsigned fixed bin(32),
     2 data (1) type byte; /* [size_is] */

 %dcl OLE2ANSI char ext;
 %if OLE2ANSI = '' %then %do;
 %dcl OLECHAR char ext;
 %OLECHAR = 'WIDECHAR';
 define alias  LPOLESTR pointer; /* to OLECHAR(*) */
 define alias LPCOLESTR pointer; /* to OLECHAR(*) nonasgn */


 %dcl OLESTR entry;
 %OLESTR: proc (str) returns (char);
   dcl str char;
   return (str); /* change when have UNICODE constants */
 %end OLESTR;

 %end;

 %dcl #WINDEF_ char ext;
 %if #WINDEF_ = '' %then %do;

 define structure
   1 RECT,
    2 left   type LONG,
    2 top    type LONG,
    2 right  type LONG,
    2 bottom type LONG;
 define alias   PRECT handle RECT;
 define alias  LPRECT handle RECT;
 define alias LPCRECT handle RECT;

 define structure
   1 RECTL,   /* rcl */
    2 left   type LONG,
    2 top    type LONG,
    2 right  type LONG,
    2 bottom type LONG;

 define alias   PRECTL handle RECTL;
 define alias  LPRECTL handle RECTL;
 define alias LPCRECTL handle RECTL;

 define alias  PVOID pointer;
 define alias LPVOID pointer;

 define alias FLOAT  float bin(21);
 define alias DOUBLE float bin(53);

 define alias UCHAR  unsigned fixed bin (8);
 define alias SHORT  fixed bin(15);
 define alias ULONG  unsigned fixed bin (32);

 %dcl #DWORDLONG_ char ext;
 %if #DWORDLONG_ = '' %then %do;
 %#DWORDLONG_ = 'Y';
 define alias DWORDLONG  unsigned fixed bin (64);
 define alias PLONGLONG  pointer;
 define alias PDWORDLONG pointer;
 %end; /* !_DWORDLONG_ */

 %dcl #ULONGLONG_ char ext;
 %if #ULONGLONG_ = '' %then %do;
 %#ULONGLONG_ = 'Y';
 define alias LONGLONG   fixed bin (63);
 define alias ULONGLONG  unsigned fixed bin (64);
 define alias PLONGLONG  pointer;
 define alias PULONGLONG pointer;
 %end; /* _ULONGLONG_ */

 %end; /*_WINDEF_ */

 %dcl #WINBASE_ char ext;
 %if #WINBASE_ = '' %then %do;

 %dcl #FILETIME_ char ext;
 %if #FILETIME_ = '' %then %do;
 %#FILETIME_ = 'Y';
 define structure
   1 FILETIME,
     2 dwLowDateTime  type DWORD,
     2 dwHighDateTime type DWORD;
 define alias  PFILETIME handle FILETIME;
 define alias LPFILETIME handle FILETIME;
 %end; /* !_FILETIME */

 %dcl #SYSTEMTIME_ char ext;
 %if #SYSTEMTIME_ = '' %then %do;
 %#SYSTEMTIME_ = 'Y';
 define structure
   1 SYSTEMTIME,
     2 wYear         type WORD,
     2 wMonth        type WORD,
     2 wDayOfWeek    type WORD,
     2 wDay          type WORD,
     2 wHour         type WORD,
     2 wMinute       type WORD,
     2 wSecond       type WORD,
     2 wMilliseconds type WORD;
 define alias  PSYSTEMTIME handle SYSTEMTIME;
 define alias LPSYSTEMTIME handle SYSTEMTIME;
 %end; /* !_SYSTEMTIME */

 %dcl #SECURITY_ATTRIBUTES_ char ext;
 %if #SECURITY_ATTRIBUTES_ = '' %then %do;
 %#SECURITY_ATTRIBUTES_ = 'Y';
 define structure
   1 SECURITY_ATTRIBUTES,
     2 nLength              type DWORD,
     2 lpSecurityDescriptor type LPVOID,
     2 bInheritHandle       type BOOL;
 define alias  PSECURITY_ATTRIBUTES handle SECURITY_ATTRIBUTES;
 define alias LPSECURITY_ATTRIBUTES handle SECURITY_ATTRIBUTES;
 %end; /* !_SECURITY_ATTRIBUTES_ */

 %dcl SECURITY_DESCRIPTOR_REVISION  fixed ext;
 %if SECURITY_DESCRIPTOR_REVISION = 0 %then %do;

 define alias  SECURITY_DESCRIPTOR_CONTROL type WORD;
 define alias PSECURITY_DESCRIPTOR_CONTROL pointer;

 define alias PSID type PVOID;

 define structure
   1 ACL,
    2 AclRevision type BYTE,
    2 Sbz1        type BYTE,
    2 AclSize     type WORD,
    2 AceCount    type WORD,
    2 Sbz2        type WORD;
 define alias PACL handle ACL;

 define structure
   1 SECURITY_DESCRIPTOR,
     2 Revision type BYTE,
     2 Sbz1     type BYTE,
     2 Control  type SECURITY_DESCRIPTOR_CONTROL,
     2 Owner    type PSID,
     2 Group    type PSID,
     2 Sacl     type PACL,
     2 Dacl     type PACL;
 define alias PISECURITY_DESCRIPTOR handle SECURITY_DESCRIPTOR;

 %end; /* !SECURITY_DESCRIPTOR_REVISION */
 %end; /*_WINBASE_ */

 define structure
   1 COAUTHIDENTITY,
     2 User           pointer, /* [size_is] */
     2 UserLength     type ULONG,
     2 Domain         pointer, /* [size_is] */
     2 DomainLength   type ULONG,
     2 Password       pointer, /* [size_is] */
     2 PasswordLength type ULONG,
     2 Flags          type ULONG;

 define structure
   1 COAUTHINFO,
     2 dwAuthnSvc           type DWORD,
     2 dwAuthzSvc           type DWORD,
     2 pwszServerPrincName  type LPWSTR,
     2 dwAuthnLevel         type DWORD,
     2 dwImpersonationLevel type DWORD,
     2 pAuthIdentityData    pointer,
     2 dwCapabilities       type DWORD;

 define alias SCODE type LONG;

 %dcl #HRESULT_DEFINED char ext;
 %if #HRESULT_DEFINED = '' %then %do;
 %#HRESULT_DEFINED = 'Y';
 define alias HRESULT type LONG;
 %end; /* !_HRESULT_DEFINED */

 define alias PSCODE pointer;

 %dcl #_OBJECTID_DEFINED char ext;
 %if #_OBJECTID_DEFINED = '' %then %do;
 %#_OBJECTID_DEFINED = 'Y';
 %dcl #OBJECTID_DEFINED char ext;
 %#OBJECTID_DEFINED = 'Y';
 define structure
   1 OBJECTID,
     2 Lineage    type GUID,
     2 Uniquifier unsigned fixed bin(32);
 %end; /* !_OBJECTID_DEFINED */

 define ordinal MEMCTX
   ( MEMCTX_SAME      value(-2),
     MEMCTX_UNKNOWN   value(-1),
     MEMCTX_TASK      value(1),
     MEMCTX_SHARED    value(2),
     MEMCTX_MACSYSTEM value(3)
   ) prec(31);

 %dcl #ROTFLAGS_DEFINED char ext;
 %if #ROTFLAGS_DEFINED = '' %then %do;
 %#ROTFLAGS_DEFINED = 'Y';
 dcl ROTFLAGS_REGISTRATIONKEEPSALIVE fixed bin(15) value('1'xn);
 dcl ROTFLAGS_ALLOWANYCLIENT         fixed bin(15) value('2'xn);
 %end; /* !_ROTFLAGS_DEFINED */

 %dcl #ROT_COMPARE_MAX_DEFINED char ext;
 %if #ROT_COMPARE_MAX_DEFINED = '' %then %do;
 %#ROT_COMPARE_MAX_DEFINED = 'Y';
 dcl ROT_COMPARE_MAX fixed bin(31) value(2048);
 %end; /* !_ROT_COMPARE_MAX_DEFINED */

 define alias CLSCTX type DWORD;
 dcl ( CLSCTX_INPROC_SERVER        value('1'xu),
       CLSCTX_INPROC_HANDLER       value('2'xu),
       CLSCTX_LOCAL_SERVER         value('4'xu),
       CLSCTX_INPROC_SERVER16      value('8'xu),
       CLSCTX_REMOTE_SERVER        value('10'xu),
       CLSCTX_INPROC_HANDLER16     value('20'xu),
       CLSCTX_INPROC_SERVERX86     value('40'xu),
       CLSCTX_INPROC_HANDLERX86    value('80'xu),
       CLSCTX_ESERVER_HANDLER      value('100'xu),
       CLSCTX_RESERVED             value('200'xu),
       CLSCTX_NO_CODE_DOWNLOAD     value('400'xu),
       CLSCTX_NO_WX86_TRANSLATION  value('800'xu),
       CLSCTX_NO_CUSTOM_MARSHAL    value('1000'xu),
       CLSCTX_ENABLE_CODE_DOWNLOAD value('2000'xu),
       CLSCTX_NO_FAILURE_LOG       value('4000'xu)
     ) type CLSCTX;

 define alias MSHLFLAGS type DWORD;
 dcl ( MSHLFLAGS_NORMAL            value(0),
       MSHLFLAGS_TABLESTRONG       value(1),
       MSHLFLAGS_TABLEWEAK         value(2),
       MSHLFLAGS_NOPING            value(4),
       MSHLFLAGS_RESERVED1         value(8),
       MSHLFLAGS_RESERVED2         value(16),
       MSHLFLAGS_RESERVED3         value(32),
       MSHLFLAGS_RESERVED4         value(64)
     ) type MSHLFLAGS;

 define ordinal MSHCTX
   ( MSHCTX_LOCAL                  value(0),
     MSHCTX_NOSHAREDMEM            value(1),
     MSHCTX_DIFFERENTMACHINE       value(2),
     MSHCTX_INPROC                 value(3),
     MSHCTX_CROSSCTX               value(4)
   ) prec(31);

 define alias DVASPECT type DWORD;
 dcl ( DVASPECT_CONTENT            value(1),
       DVASPECT_THUMBNAIL          value(2),
       DVASPECT_ICON               value(4),
       DVASPECT_DOCPRINT           value(8)
     ) type DVASPECT;

 define alias STGC type DWORD;
 dcl ( STGC_DEFAULT                value(0),
       STGC_OVERWRITE              value(1),
       STGC_ONLYIFCURRENT          value(2),
       STGC_DANGEROUSLYCOMMITMERELYTODISKCACHE value(4),
       STGC_CONSOLIDATE            value(8)
     ) type STGC;

 define ordinal STGMOVE
   ( STGMOVE_MOVE                  value(0),
     STGMOVE_COPY                  value(1),
     STGMOVE_SHALLOWCOPY           value(2)
   ) prec(31);

 define alias STATFLAG type DWORD;
 dcl ( STATFLAG_DEFAULT            value(0),
       STATFLAG_NONAME             value(1),
       STATFLAG_NOOPEN             value(2)
     ) type STATFLAG;

 define alias HCONTEXT pointer; /* [context_handle] */


 %dcl #LCID_DEFINED char ext;
 %if #LCID_DEFINED = '' %then %do;
 %#LCID_DEFINED = 'Y';
 define alias LCID type DWORD;
 %end; /* !_LCID_DEFINED */
 %dcl #LANGID_DEFINED char ext;
 %if #LANGID_DEFINED = '' %then %do;
 %#LANGID_DEFINED = 'Y';
 define alias LANGID type USHORT;
 %end; /* !_LANGID_DEFINED */

 define structure
   1 BYTE_BLOB,
     2 clSize     unsigned fixed bin(32),
     2 abData (1) type byte; /* [size_is] */
 define alias UP_BYTE_BLOB handle BYTE_BLOB;

 define structure
   1 WORD_BLOB,
     2 clSize     unsigned fixed bin(32),
     2 asData (1) unsigned fixed bin(32);  /* [size_is] */
 define alias UP_WORD_BLOB handle WORD_BLOB;

 define structure
   1 DWORD_BLOB,
     2 clSize     unsigned fixed bin(32),
     2 alData (1) unsigned fixed bin(32); /* [size_is] */
 define alias UP_DWORD_BLOB handle DWORD_BLOB;

 define structure
   1 FLAGGED_BYTE_BLOB,
     2 fFlags     unsigned fixed bin(32),
     2 clSize     unsigned fixed bin(32),
     2 abData (1) type byte; /* [size_is] */
 define alias UP_FLAGGED_BYTE_BLOB handle FLAGGED_BYTE_BLOB;

 define structure
   1 FLAGGED_WORD_BLOB,
     2 fFlags     unsigned fixed bin(32),
     2 clSize     unsigned fixed bin(32),
     2 asData (1) unsigned fixed bin(32);  /* [size_is] */
 define alias UP_FLAGGED_WORD_BLOB handle FLAGGED_WORD_BLOB;

 define structure
   1 BYTE_SIZEDARR,
     2 clSize unsigned fixed bin(32),
     2 pData  pointer; /* [size_is] */

 define structure
   1 SHORT_SIZEDARR,
     2 clSize unsigned fixed bin(32),
     2 pData  pointer; /* [size_is] */

 define structure
   1 LONG_SIZEDARR,
     2 clSize unsigned fixed bin(32),
     2 pData  pointer; /* [size_is] */

 define structure
   1 HYPER_SIZEDARR,
     2 clSize unsigned fixed bin(32),
     2 pData  pointer; /* [size_is] */

 dcl WDT_INPROC_CALL   fixed bin(31) value('48746457'xn);

 dcl WDT_REMOTE_CALL   fixed bin(31) value('52746457'xn);

 dcl WDT_INPROC64_CALL fixed bin(31) value('50746457'xn);

 define structure
   1 userCLIPFORMAT,
     2 fContext fixed bin(31),
     2 u union,                    /* [switch_is] */ /* [switch_type] */
       3 dwValue  type DWORD,      /* [case()] */
       3 pwszName pointer;         /* [case()][string] */

 define alias wireCLIPFORMAT handle userCLIPFORMAT; /* [unique] */

 define alias CLIPFORMAT type WORD;/* [wire_marshal] */

 define structure
   1 GDI_NONREMOTE,
     2 fContext fixed bin(31),
     2 u union,                    /* [switch_is] */ /* [switch_type] */
       3 hInproc fixed bin(31),    /* [case()] */
       3 hRemote pointer;          /* [case()] */

 define structure
   1 userHGLOBAL,
     2 fContext fixed bin(31),
     2 u union,                    /* [switch_is] */ /* [switch_type] */
       3 hInproc fixed bin(31),    /* [case()] */
       3 hRemote pointer,          /* [case()] */
       3 hGlobal fixed bin(31);    /* [default] */

 define alias wireHGLOBAL handle userHGLOBAL; /* [unique] */

 define structure
   1 userHMETAFILE,
     2 fContext fixed bin(31),
     2 u union,                    /* [switch_is] */ /* [switch_type] */
       3 hInproc fixed bin(31),    /* [case()] */
       3 hRemote pointer,          /* [case()] */
       3 hGlobal fixed bin(31);    /* [default] */

 define structure
   1 remoteMETAFILEPICT,
     2 mm   fixed bin(31),
     2 xExt fixed bin(31),
     2 yExt fixed bin(31),
     2 hMF  pointer;

 define structure
   1 userHMETAFILEPICT,
     2 fContext fixed bin(31),
     2 u union,                    /* [switch_is] */ /* [switch_type] */
       3 hInproc fixed bin(31),    /* [case()] */
       3 hRemote pointer,          /* [case()] */
       3 hGlobal fixed bin(31);    /* [default] */

 define structure
   1 userHENHMETAFILE,
     2 fContext fixed bin(31),
     2 u union,                    /* [switch_is] */ /* [switch_type] */
       3 hInproc fixed bin(31),    /* [case()] */
       3 hRemote pointer,          /* [case()] */
       3 hGlobal fixed bin(31);    /* [default] */

 define structure
   1 userBITMAP,
     2 bmType       type LONG,
     2 bmWidth      type LONG,
     2 bmHeight     type LONG,
     2 bmWidthBytes type LONG,
     2 bmPlanes     type WORD,
     2 bmBitsPixel  type WORD,
     2 cbSize       type ULONG,
     2 pBuffer (1)  type byte; /* [size_is] */

 define structure
   1 userHBITMAP,
     2 fContext fixed bin(31),
     2 u union,                    /* [switch_is] */ /* [switch_type] */
       3 hInproc fixed bin(31),    /* [case()] */
       3 hRemote pointer,          /* [case()] */
       3 hGlobal fixed bin(31);    /* [default] */

 %dcl #WINGDI_ char ext;
 %dcl NOGDI char ext;
 %if #WINGDI_^='' & NOGDI='' %then %do;
 define structure
   1 rpcLOGPALETTE,
     2 palVersion      type WORD,
     2 palNumEntries   type WORD,
     2 palPalEntry (1) type PALETTEENTRY;  /* [size_is] */

 define structure
   1 userHPALETTE,
     2 fContext fixed bin(31),
     2 u union,                    /* [switch_is] */ /* [switch_type] */
       3 hInproc fixed bin(31),    /* [case()] */
       3 hRemote pointer,          /* [case()] */
       3 hGlobal fixed bin(31);    /* [default] */
 %end;  /* (defined(_WINGDI_) && !defined(NOGDI)) */

 define structure
   1 RemotableHandle,
     2 fContext fixed bin(31),
     2 u union,                    /* [switch_is] */ /* [switch_type] */
       3 hInproc fixed bin(31),    /* [case()] */
       3 hRemote fixed bin(31);    /* [case()] */

 define alias wireHWND          handle RemotableHandle;

 define alias wireHMENU         handle RemotableHandle;

 define alias wireHACCEL        handle RemotableHandle;

 define alias wireHBRUSH        handle RemotableHandle;

 define alias wireHFONT         handle RemotableHandle;

 define alias wireHDC           handle RemotableHandle;

 define alias wireHICON         handle RemotableHandle;

 define alias wireHBITMAP       handle userHBITMAP;

 %if #WINGDI_^='' & NOGDI='' %then %do;
 define alias wireHPALETTE      handle userHPALETTE;
 %end; /* (defined(_WINGDI_) && !defined(NOGDI)) */

 define alias wireHENHMETAFILE  handle userHENHMETAFILE;

 define alias wireHMETAFILE     handle userHMETAFILE;

 define alias wireHMETAFILEPICT handle userHMETAFILEPICT;

 define alias HMETAFILEPICT pointer; /* [wire_marshal] */

 dcl IWinTypes_v0_1_c_ifspec type RPC_IF_HANDLE ext static;
 dcl IWinTypes_v0_1_s_ifspec type RPC_IF_HANDLE ext static;
 %end; /* __IWinTypes_INTERFACE_DEFINED__ */

 /* interface __MIDL_itf_wtypes_0003 */
 /* [local] */

 define alias DATE float bin (53);

 %dcl #tagCY_DEFINED char ext;
 %if #tagCY_DEFINED = '' %then %do;
 %#tagCY_DEFINED = 'Y';
 %dcl #CY_DEFINED char ext;
 %#CY_DEFINED = 'Y';

 define structure
 1 CY union,
     2 *,
       3 Lo unsigned fixed bin(32),
       3 Hi fixed bin(31),
     2 int64 type LONGLONG;
 %end; /* _tagCY_DEFINED */
 define alias LPCY handle CY;

 define structure
   1 DECIMAL,
     2 wReserved type USHORT,
     2 *         union,
       3 *,
         4 scale   type BYTE,
         4 sign    type BYTE,
       3 signscale type USHORT,
     2 Hi32      type ULONG,
     2 *         union,
       3 *,
         4 Lo32    type ULONG,
         4 Mid32   type ULONG,
       3 Lo64    type ULONGLONG;

 dcl DECIMAL_NEG type BYTE  value('80'xn);

 DECIMAL_SETZERO: proc (dec) options (inline reorder) internal;
   dcl dec type DECIMAL byaddr;
   dec.Lo64 = 0;
   dec.Hi32 = 0;
   dec.signscale = 0;
 end DECIMAL_SETZERO;

 define alias LPDECIMAL handle DECIMAL;

 define alias wireBSTR handle FLAGGED_WORD_BLOB; /* [unique] */

 define alias BSTR   pointer; /* [wire_marshal] */

 define alias LPBSTR pointer;

 /* 0 == FALSE, -1 == TRUE */
 define alias VARIANT_BOOL fixed bin(15);


 /* The BSTRBLOB structure is used by some implementations  */
 /* of the IPropertyStorage interface when marshaling BSTRs */
 /* on systems which don't support BSTR marshaling.         */
 %dcl #tagBSTRBLOB_DEFINED char ext;
 %if #tagBSTRBLOB_DEFINED = '' %then %do;
 %#tagBSTRBLOB_DEFINED = 'Y';
 define structure
   1 BSTRBLOB,
     2 cbSize type ULONG,
     2 pData  pointer; /* [size_is] */
 define alias LPBSTRBLOB handle BSTRBLOB;

 %end;

 dcl VARIANT_TRUE  type VARIANT_BOOL value(-1 );
 dcl VARIANT_FALSE type VARIANT_BOOL value(0);
 %dcl #tagBLOB_DEFINED char ext;
 %if #tagBLOB_DEFINED = '' %then %do;
 %#tagBLOB_DEFINED = 'Y';
 %dcl #BLOB_DEFINED char ext;
 %#BLOB_DEFINED = 'Y';
 %dcl #LPBLOB_DEFINED char ext;
 %#LPBLOB_DEFINED = 'Y';
 define structure
   1 BLOB,
     2 cbSize    type ULONG,
     2 pBlobData pointer; /* [size_is] */
 define alias LPBLOB handle BLOB;

 %end;

 define structure
   1 CLIPDATA,
     2 cbSize    type ULONG,
     2 ulClipFmt fixed bin(31),
     2 pClipData pointer; /* [size_is] */

 /* Macro to calculate the size of the above pClipData */
 CBPCLIPDATA: proc (clipdata) returns (fixed bin (31) byvalue)
              options (inline reorder) internal;
   dcl clipdata type CLIPDATA byaddr nonasgn;
   dcl stg builtin;
   return (clipdata.cbSize - stg (clipdata.ulClipFmt));
 end CBPCLIPDATA;

 define alias VARTYPE unsigned fixed bin(16);

 /* VARENUM usage key,                                                */
 /*                                                                   */
 /* * [V] - may appear in a VARIANT                                   */
 /* * [T] - may appear in a TYPEDESC                                  */
 /* * [P] - may appear in an OLE property set                         */
 /* * [S] - may appear in a Safe Array                                */
 /*                                                                   */
 /*                                                                   */
 /*  VT_EMPTY            [V]   [P]     nothing                        */
 /*  VT_NULL             [V]   [P]     SQL style Null                 */
 /*  VT_I2               [V][T][P][S]  2 byte signed int              */
 /*  VT_I4               [V][T][P][S]  4 byte signed int              */
 /*  VT_R4               [V][T][P][S]  4 byte real                    */
 /*  VT_R8               [V][T][P][S]  8 byte real                    */
 /*  VT_CY               [V][T][P][S]  currency                       */
 /*  VT_DATE             [V][T][P][S]  date                           */
 /*  VT_BSTR             [V][T][P][S]  OLE Automation string          */
 /*  VT_DISPATCH         [V][T]   [S]  IDispatch *                    */
 /*  VT_ERROR            [V][T][P][S]  SCODE                          */
 /*  VT_BOOL             [V][T][P][S]  True=-1, False=0               */
 /*  VT_VARIANT          [V][T][P][S]  VARIANT *                      */
 /*  VT_UNKNOWN          [V][T]   [S]  IUnknown *                     */
 /*  VT_DECIMAL          [V][T]   [S]  16 byte fixed point            */
 /*  VT_RECORD           [V]   [P][S]  user defined type              */
 /*  VT_I1               [V][T][P][s]  signed char                    */
 /*  VT_UI1              [V][T][P][S]  unsigned char                  */
 /*  VT_UI2              [V][T][P][S]  unsigned short                 */
 /*  VT_UI4              [V][T][P][S]  unsigned short                 */
 /*  VT_I8                  [T][P]     signed 64-bit int              */
 /*  VT_UI8                 [T][P]     unsigned 64-bit int            */
 /*  VT_INT              [V][T][P][S]  signed machine int             */
 /*  VT_UINT             [V][T]   [S]  unsigned machine int           */
 /*  VT_VOID                [T]        C style void                   */
 /*  VT_HRESULT             [T]        Standard return type           */
 /*  VT_PTR                 [T]        pointer type                   */
 /*  VT_SAFEARRAY           [T]        (use VT_ARRAY in VARIANT)      */
 /*  VT_CARRAY              [T]        C style array                  */
 /*  VT_USERDEFINED         [T]        user defined type              */
 /*  VT_LPSTR               [T][P]     null terminated string         */
 /*  VT_LPWSTR              [T][P]     wide null terminated string    */
 /*  VT_FILETIME               [P]     FILETIME                       */
 /*  VT_BLOB                   [P]     Length prefixed bytes          */
 /*  VT_STREAM                 [P]     Name of the stream follows     */
 /*  VT_STORAGE                [P]     Name of the storage follows    */
 /*  VT_STREAMED_OBJECT        [P]     Stream contains an object      */
 /*  VT_STORED_OBJECT          [P]     Storage contains an object     */
 /*  VT_VERSIONED_STREAM       [P]     Stream with a GUID version     */
 /*  VT_BLOB_OBJECT            [P]     Blob contains an object        */
 /*  VT_CF                     [P]     Clipboard format               */
 /*  VT_CLSID                  [P]     A Class ID                     */
 /*  VT_VECTOR                 [P]     simple counted array           */
 /*  VT_ARRAY            [V]           SAFEARRAY*                     */
 /*  VT_BYREF            [V]           void* for local use            */
 /*  VT_BSTR_BLOB                      Reserved for system use        */

 define ordinal VARENUM
   ( VT_EMPTY            value(0),
     VT_NULL             value(1),
     VT_I2               value(2),
     VT_I4               value(3),
     VT_R4               value(4),
     VT_R8               value(5),
     VT_CY               value(6),
     VT_DATE             value(7),
     VT_BSTR             value(8),
     VT_DISPATCH         value(9),
     VT_ERROR            value(10),
     VT_BOOL             value(11),
     VT_VARIANT          value(12),
     VT_UNKNOWN          value(13),
     VT_DECIMAL          value(14),
     VT_I1               value(16),
     VT_UI1              value(17),
     VT_UI2              value(18),
     VT_UI4              value(19),
     VT_I8               value(20),
     VT_UI8              value(21),
     VT_INT              value(22),
     VT_UINT             value(23),
     VT_VOID             value(24),
     VT_HRESULT          value(25),
     VT_PTR              value(26),
     VT_SAFEARRAY        value(27),
     VT_CARRAY           value(28),
     VT_USERDEFINED      value(29),
     VT_LPSTR            value(30),
     VT_LPWSTR           value(31),
     VT_RECORD           value(36),
     VT_FILETIME         value(64),
     VT_BLOB             value(65),
     VT_STREAM           value(66),
     VT_STORAGE          value(67),
     VT_STREAMED_OBJECT  value(68),
     VT_STORED_OBJECT    value(69),
     VT_BLOB_OBJECT      value(70),
     VT_CF               value(71),
     VT_CLSID            value(72),
     VT_VERSIONED_STREAM value(73),
     VT_BSTR_BLOB        value('fff'xn),
     VT_VECTOR           value('1000'xn),
     VT_ARRAY            value('2000'xn),
     VT_BYREF            value('4000'xn),
     VT_RESERVED         value('8000'xn),
     VT_ILLEGAL          value('ffff'xn)
    ) prec (31);
 dcl VT_ILLEGALMASKED type VARENUM value(VT_BSTR_BLOB /* 'fff'xn */),
     VT_TYPEMASK      type VARENUM value(VT_BSTR_BLOB /* 'fff'xn */);


 %dcl #WIN64 char ext;
 %if #WIN64 ^= '' %then %do;
 dcl VT_INT_PTR  type VARENUM value(VT_I8),
     VT_UINT_PTR type VARENUM value(VT_UI8);
 %end; %else %do;
 dcl VT_INT_PTR  type VARENUM value(VT_I4),
     VT_UINT_PTR type VARENUM value(VT_UI4);
 %end;

 define alias PROPID type ULONG;

 %dcl SID_IDENTIFIER_AUTHORITY_DEFINED char ext;
 %if SID_IDENTIFIER_AUTHORITY_DEFINED = '' %then %do;
 %SID_IDENTIFIER_AUTHORITY_DEFINED = 'Y';
 define structure
   1 SID_IDENTIFIER_AUTHORITY,
     2 Value (6) type BYTE;
 define alias PSID_IDENTIFIER_AUTHORITY handle SID_IDENTIFIER_AUTHORITY;
 %end;
 %dcl SID_DEFINED char ext;
 %if SID_DEFINED = '' %then %do;
 %SID_DEFINED = 'Y';
 define structure
   1 SID,
     2 Revision            type BYTE,
     2 SubAuthorityCount   type BYTE,
     2 IdentifierAuthority type SID_IDENTIFIER_AUTHORITY,
     2 SubAuthority (ANYSIZE_ARRAY) type DWORD;
 define alias PISID handle SID;

 define structure
   1 SID_AND_ATTRIBUTES,
     2 Sid        type PSID,
     2 Attributes type DWORD;
 define alias PSID_AND_ATTRIBUTES handle SID_AND_ATTRIBUTES;
 %end;

 define alias APPID type GUID;

 define structure
   1 CSPLATFORM,
     2 dwPlatformId    type DWORD,
     2 dwVersionHi     type DWORD,
     2 dwVersionLo     type DWORD,
     2 dwProcessorArch type DWORD;

 define structure
   1 QUERYCONTEXT,
     2 dwContext   type DWORD,
     2 Platform    type CSPLATFORM,
     2 Locale      type LCID,
     2 dwVersionHi type DWORD,
     2 dwVersionLo type DWORD;

 define ordinal TYSPEC
   ( TYSPEC_CLSID       value(0),
     TYSPEC_FILEEXT     value(1), /* TYSPEC_CLSID       + 1 */
     TYSPEC_MIMETYPE    value(2), /* TYSPEC_FILEEXT     + 1 */
     TYSPEC_FILENAME    value(3), /* TYSPEC_MIMETYPE    + 1 */
     TYSPEC_PROGID      value(4), /* TYSPEC_FILENAME    + 1 */
     TYSPEC_PACKAGENAME value(5), /* TYSPEC_PROGID      + 1 */
     TYSPEC_OBJECTID    value(6)  /* TYSPEC_PACKAGENAME + 1 */
   ) prec (31);

 define structure
   1 uCLSSPEC, /* [public] */
     2 tyspec type DWORD,
     2 tagged_union union, /* [switch_is] */ /* [switch_type] */
       3 clsid          type CLSID,    /* [case()] */
       3 pFileExt       type LPOLESTR, /* [case()] */
       3 pMimeType      type LPOLESTR, /* [case()] */
       3 pProgId        type LPOLESTR, /* [case()] */
       3 pFileName      type LPOLESTR, /* [case()] */
       3 ByName,                       /* [case()] */
         4 pPackageName type LPOLESTR,
         4 PolicyId     type GUID,
       3 ByObjectId,                   /* [case()] */
         4 ObjectId     type GUID,
         4 PolicyId     type GUID;


 dcl ACTFLG_RunLocally               fixed bin(31) value('1'xn);
 dcl ACTFLG_RunOnce                  fixed bin(31) value('2'xn);
 dcl ACTFLG_SystemWide               fixed bin(31) value('4'xn);
 dcl ACTFLG_Published                fixed bin(31) value('8'xn);
 dcl ACTFLG_UserInstall              fixed bin(31) value('20'xn);
 dcl ACTFLG_OnDemandInstall          fixed bin(31) value('40'xn);
 dcl ACTFLG_Orphan                   fixed bin(31) value('80'xn);
 dcl ACTFLG_Uninstall                fixed bin(31) value('100'xn);
 dcl ACTFLG_Pilot                    fixed bin(31) value('200'xn);
 dcl ACTFLG_Assigned                 fixed bin(31) value('400'xn);
 dcl ACTFLG_OrphanOnPolicyRemoval    fixed bin(31) value('800'xn);
 dcl ACTFLG_UninstallOnPolicyRemoval fixed bin(31) value('1000'xn);
 dcl ACTFLG_Migrate                  fixed bin(31) value('2000'xn);
 dcl ACTFLG_ForceUpgrade             fixed bin(31) value('4000'xn);
 dcl ACTFLG_MinimalInstallUI         fixed bin(31) value('8000'xn);
 dcl ACTFLG_X86OnAlpha               fixed bin(31) value('10000'xn);
 dcl ACTFLG_IgnoreLanguage           fixed bin(31) value('20000'xn);

 dcl UPGFLG_Uninstall                fixed bin(31) value('1'xn);
 dcl UPGFLG_NoUninstall              fixed bin(31) value('2'xn);
 dcl UPGFLG_UpgradedBy               fixed bin(31) value('4'xn);
 dcl UPGFLG_Enforced                 fixed bin(31) value('8'xn);

 define ordinal CLASSPATHTYPE
   ( ExeNamePath   value(0),
     DllNamePath   value(1), /* ExeNamePath + 1 */
     TlbNamePath   value(2), /* DllNamePath + 1 */
     CabFilePath   value(3), /* TlbNamePath + 1 */
     InfFilePath   value(4), /* CabFilePath + 1 */
     DrwFilePath   value(5), /* InfFilePath + 1 */
     SetupNamePath value(6)  /* DrwFilePath + 1 */
   ) PREC(31);

 define structure
   1 UPGRADEINFO,
     2 szClassStore type LPOLESTR,
     2 PackageGuid  type GUID,
     2 Flag         type DWORD;

 define structure
   1 CLASSDETAIL,
     2 Clsid             type CLSID,
     2 TreatAs           type CLSID,
     2 dwComClassContext type DWORD,
     2 cProgId           type DWORD,
     2 prgProgId         pointer;          /* [size_is] */

 define structure
   1 ACTIVATIONINFO,
     2 cClasses        type UINT,
     2 pClasses        handle CLASSDETAIL, /* [size_is] */
     2 cShellFileExt   type UINT,
     2 prgShellFileExt pointer,            /* [size_is] */
     2 prgPriority     pointer,            /* [size_is] */
     2 cInterfaces     type UINT,
     2 prgInterfaceId  handle IID,         /* [size_is] */
     2 cTypeLib        type UINT,
     2 prgTlbId        handle GUID;        /* [size_is] */

 define structure
   1 INSTALLINFO,
     2 dwActFlags         type DWORD,
     2 PathType           type CLASSPATHTYPE,
     2 pszScriptPath      type LPOLESTR,
     2 pszSetupCommand    type LPOLESTR,
     2 pszUrl             type LPOLESTR,
     2 Usn                type ULONGLONG,
     2 InstallUiLevel     type UINT,
     2 pClsid             handle GUID,
     2 ProductCode        type GUID,
     2 PackageGuid        type GUID,
     2 Mvipc              type GUID,
     2 dwVersionHi        type DWORD,
     2 dwVersionLo        type DWORD,
     2 dwRevision         type DWORD,
     2 cUpgrades          type UINT,
     2 prgUpgradeInfoList handle UPGRADEINFO, /* [size_is] */
     2 cScriptLen         type ULONG;

 define structure
   1 PLATFORMINFO,
     2 cPlatforms     type UINT,
     2 prgPlatform    handle CSPLATFORM,      /* [size_is] */
     2 cLocales       type UINT,
     2 prgLocale      pointer;                /* [size_is] */

 define structure
   1 PACKAGEDETAIL,
     2 pszPackageName type LPOLESTR,
     2 pszPublisher   type LPOLESTR,
     2 cSources       type UINT,
     2 pszSourceList  pointer,                /* [size_is] */
     2 cCategories    type UINT,
     2 rpCategory     handle GUID,            /* [size_is] */
     2 pActInfo       handle ACTIVATIONINFO,
     2 pPlatformInfo  handle PLATFORMINFO,
     2 pInstallInfo   handle INSTALLINFO;


 dcl __MIDL_itf_wtypes_0003_v0_0_c_ifspec type RPC_IF_HANDLE ext static;
 dcl __MIDL_itf_wtypes_0003_v0_0_s_ifspec type RPC_IF_HANDLE ext static;

 /* Additional Prototypes for ALL interfaces */

 /* end of Additional Prototypes */

 %end; /* #_wtypes_h__ */

